/* Copyright (c) 1988 by Carrick Sean Casey. All rights reserved. */

/* connect to a port */

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include "select.h"
#include "ipcf.h"
#include "externs.h"

struct in_addr *_getaddress();

connecttoport(host_name, port_number)
char *host_name;
int port_number;
{
	int s;
	struct sockaddr_in saddr;
	struct in_addr *addr;

	/* get the client host inet address */
	if ((addr = _getaddress(host_name)) == 0) {
		perror("can't lookup server INET address");
		return(-1);
	}

	/* insert hostname into address */
	bzero((char *) &saddr, sizeof(saddr));
	bcopy((char *) addr, (char *) &saddr.sin_addr, 4);

	/* fill in socket domain and port number */
	saddr.sin_family = AF_INET;
	saddr.sin_port = htons((u_short)port_number);

	/* create a socket */
	if ((s = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
		perror("couldn't create socket");
		return(-1);
	}

	/* connect it to the server inet address */
	if (connect(s, (struct sockaddr *) &saddr, sizeof(saddr)) < 0) {
		perror("couldn't connect to server (not running?)");
		return(-1);
	}

	port_fd = s;
	return(0);
}
