/* return a remote connection's host name, or NULL if it */
/* can't be looked up */

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/nameser.h>
#include "/usr/include/resolv.h"

char *
getremotename(s)
int s;			/* connected socket fd */
{
	static char rname[256];
	struct hostent *host;
	struct sockaddr_in rs;
	int rs_size = sizeof(rs);
	char *inet_ntoa();
	char tbuf[256];

	/* Don't want to wast all our time in resolving stuff... */
	_res.retrans = 3;
	_res.retry = 2;
#ifdef VERBOSE
	sprintf(tbuf, "[INFO] retrans = %d, retry = %d, options = %d",
		_res.retrans, _res.retry, _res.options);
	mdb(tbuf);
#endif
	mdb("[INFO] Starting hostname lookup");
	bzero(rname, 256);
	/* get address of remote user */
	if (getpeername(s, &rs, &rs_size) < 0) {
		perror("server: getpeername failed");
		return(NULL);
	}

	/* get hostname from table */
	if ((host = gethostbyaddr(&rs.sin_addr.s_addr,
	  sizeof(rs.sin_addr.s_addr), AF_INET)) == 0) {
		sprintf(rname, "[%s]", inet_ntoa(rs.sin_addr));
		sprintf(tbuf, "[INFO] Can not resolve %s", 
			inet_ntoa(rs.sin_addr));
		mdb(tbuf);
		}
	else {
		strcpy(rname, host->h_name);
		}
return(rname);
}
