/* Copyright (c) 1988 Carrick Sean Casey. All rights reserved. */

/* start listening on our official port */
/* returns socket for new connects */

#include <stdio.h>
#include "config.h"
#ifdef FCNTL
#include <fcntl.h>
#endif FCNTL
#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include "select.h"
#include "ipcf.h"
#include "externs.h"
 
makenewport(host_name, port_number)
char *host_name;
int port_number;
{
	struct sockaddr_in saddr;
	struct hostent *hp;
	int one = 1;
	int s;
	int flags;

	/* get the server host inet address */
	/* don't need to do this -- RCD */
#if 0
	if ((hp = gethostbyname(host_name)) < (struct hostent *) 0) {
		perror("makenewport: gethostbyname");
		return(-1);
	}
#endif

	/* insert host_name into address */
	bzero((char *) &saddr, sizeof(saddr));
	saddr.sin_family = AF_INET;
	saddr.sin_addr.s_addr = htonl(INADDR_ANY);
	saddr.sin_port = htons(port_number);

	/* create a socket */
	if ((s = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
		perror("makenewport: gethostbyname");
		return(-1);
	}

	/* bind it to the inet address */
	if (bind(s, (struct sockaddr *) &saddr, sizeof(saddr)) < 0) {
		perror("makenewport: bind");
		perror("perror says:");
		return(-1);
	}

	/* start listening for connections */
	listen(s, 5);

	/* make it non-blocking */
	if (fcntl(s, F_SETFL, FNDELAY) < 0) {
		perror("makenewport: fcntl");
		return(-1);
	}

	/* Don't close on exec */
	flags = fcntl(s, F_GETFD, 0);
	flags = flags & ~ FD_CLOEXEC;
	if (fcntl(s, F_SETFD, flags) < 0) {
		perror("CLOEXEC");
		exit (-1);
	}

	/* force occasional connection check */
	if (setsockopt(s, SOL_SOCKET, SO_REUSEADDR,
	  (char *)&one, sizeof(one)) < 0) {
		puts("makeport:setsockopt (makeport)");
/*		return(-1);*/
	}

	one = 24576;
	if (setsockopt(s, SOL_SOCKET, SO_SNDBUF,
	   (char *)&one, sizeof(one)) < 0) {
		perror("SO_SNDBUF");
		}

	/* allow us to handle problems gracefully */
	signal(SIGPIPE, SIG_IGN);

	port_fd = s;
	return(0);
}
