#include "server.h"
#include "externs.h"
#include "config.h"
#include <strings.h>
#include <ndbm.h>
#include <fcntl.h>
#include <time.h>

int
setsecure(forWhom, secure)
	int            forWhom;
	int            secure;
{
	DBM            *db;
	char           key[64];
	datum          result, key_dat, request;
	char           line[255];
	int            retval, i;

	if (strlen(u_tab[forWhom].realname) == 0) {
		senderror(forWhom, 
			"You must be registered to change your security.");
		return -1;
		}

	if ((db = dbm_open(USERDB, O_RDWR)) == NULL) {
		sprintf(line, "[ERROR] User Database Open: %s", 
			sys_errlist[errno]);
		mdb(line);
		sprintf(line, "User Database Open: %s", sys_errlist[errno]);
		senderror(forWhom, line);
		return -1;
		}
	if (secure == 0) {
		strcpy(key, u_tab[forWhom].nickname);
		strcat(key, ".secure");
		lcaseit(key);
		key_dat.dptr = key;
		key_dat.dsize = strlen(key);
		result = dbm_fetch(db, key_dat);
		if (result.dptr)
			dbm_delete(db, key_dat);
		sends_cmdout (forWhom, "Security set to automatic.");
		}
	else if (secure == 1) {
		strcpy(key, u_tab[forWhom].nickname);
		strcat(key, ".secure");
		lcaseit(key);
		key_dat.dptr = key;
		key_dat.dsize = strlen(key);
		bzero(line, 255);
		strcpy(line, "SECURED");
		request.dptr = line;
		request.dsize = strlen(line);
		result = dbm_fetch(db, key_dat);
		if (!result.dptr)
			dbm_store(db, key_dat, request, DBM_INSERT);
		else 
			dbm_store(db, key_dat, request, DBM_REPLACE);
		sends_cmdout (forWhom, "Security set to password required.");
		}
	else {
		mdb("Illegal setsecure value");
		retval = -2;
		}
	dbm_close(db);
	return retval;
}

int
valuser(user, password)
	char           *user;
	char           *password;
{
	DBM            *db;
	char           key[64];
	datum          result, key_dat, request;
	char           line[255];
	int            retval, i;

	if (strlen(password) <= 0)
		return -1;

	if ((db = dbm_open(USERDB, O_RDWR)) == NULL) {
                sprintf(line, "[ERROR] User Database Open: %s", 
                        sys_errlist[errno]);
                mdb(line);
		return -1;
		}

	strcpy(key, user);
	strcat(key, ".password");
	lcaseit(key);
	key_dat.dptr = key;
	key_dat.dsize = strlen(key);
	result = dbm_fetch(db, key_dat);
	if (!result.dptr) 
		return -1;	/* not found */
	bzero(line, 255);
	strncpy(line, result.dptr, result.dsize);
	dbm_close(db);
	if (strcmp(line, password) != 0)
		return -1;
	else
		return 0;
}

int
nickdelete(forWhom)
	int		forWhom;
{
	DBM            *db;
	char           key[64];
	datum          result, key_dat, request;
	char           line[255], timebuf[255];
	int            count, i;

	if (strlen(u_tab[forWhom].realname) == 0) {
		senderror(forWhom, 
			"You must be registered to delete your entry.");
		return -1;
		}

	if ((db = dbm_open(USERDB, O_RDWR)) == NULL) {
                sprintf(line, "[ERROR] User Database Open: %s", 
                        sys_errlist[errno]);
                mdb(line);
                sprintf(line, "User Database Open: %s", sys_errlist[errno]);
                senderror(forWhom, line);
		return -1;
		}

	bzero(line, 255);
	strcpy(key, u_tab[forWhom].nickname);
	strcat(key, ".secure");
	lcaseit(key);
	key_dat.dptr = key;
	key_dat.dsize = strlen(key);
	result = dbm_fetch(db, key_dat);
	if (result.dptr)
		dbm_delete(db, key_dat);
	bzero(line, 255);
	bzero(line, 255);
	strcpy(key, u_tab[forWhom].nickname);
	strcat(key, ".realname");
	lcaseit(key);
	key_dat.dptr = key;
	key_dat.dsize = strlen(key);
	result = dbm_fetch(db, key_dat);
	if (result.dptr)
		dbm_delete(db, key_dat);
	bzero(line, 255);
	strcpy(key, u_tab[forWhom].nickname);
	strcat(key, ".email");
	lcaseit(key);
	key_dat.dptr = key;
	key_dat.dsize = strlen(key);
	result = dbm_fetch(db, key_dat);
	if (result.dptr)
		dbm_delete(db, key_dat);
	bzero(line, 255);
	strcpy(key, u_tab[forWhom].nickname);
	strcat(key, ".signoff");
	lcaseit(key);
	key_dat.dptr = key;
	key_dat.dsize = strlen(key);
	result = dbm_fetch(db, key_dat);
	if (result.dptr)
		dbm_delete(db, key_dat);
	bzero(line, 255);
	strcpy(key, u_tab[forWhom].nickname);
	strcat(key, ".signon");
	lcaseit(key);
	key_dat.dptr = key;
	key_dat.dsize = strlen(key);
	result = dbm_fetch(db, key_dat);
	if (result.dptr)
		dbm_delete(db, key_dat);
	bzero(line, 255);
	strcpy(key, u_tab[forWhom].nickname);
	strcat(key, ".nick");
	lcaseit(key);
	key_dat.dptr = key;
	key_dat.dsize = strlen(key);
	result = dbm_fetch(db, key_dat);
	if (result.dptr)
		dbm_delete(db, key_dat);
	bzero(line, 255);
	strcpy(key, u_tab[forWhom].nickname);
	strcat(key, ".password");
	lcaseit(key);
	key_dat.dptr = key;
	key_dat.dsize = strlen(key);
	result = dbm_fetch(db, key_dat);
	if (result.dptr)
		dbm_delete(db, key_dat);
	bzero(line, 255);
	strcpy(key, u_tab[forWhom].nickname);
	strcat(key, ".phone");
	lcaseit(key);
	key_dat.dptr = key;
	key_dat.dsize = strlen(key);
	result = dbm_fetch(db, key_dat);
	if (result.dptr)
		dbm_delete(db, key_dat);
	bzero(line, 255);
	strcpy(key, u_tab[forWhom].nickname);
	strcat(key, ".text");
	lcaseit(key);
	key_dat.dptr = key;
	key_dat.dsize = strlen(key);
	result = dbm_fetch(db, key_dat);
	if (result.dptr)
		dbm_delete(db, key_dat);
	bzero(line, 255);
	strcpy(key, u_tab[forWhom].nickname);
	strcat(key, ".home");
	lcaseit(key);
	key_dat.dptr = key;
	key_dat.dsize = strlen(key);
	result = dbm_fetch(db, key_dat);
	if (result.dptr)
		dbm_delete(db, key_dat);
	bzero(line, 255);
	strcpy(key, u_tab[forWhom].nickname);
	strcat(key, ".addr");
	lcaseit(key);
	key_dat.dptr = key;
	key_dat.dsize = strlen(key);
	result = dbm_fetch(db, key_dat);
	if (result.dptr)
		dbm_delete(db, key_dat);
	bzero(line, 255);
	strcpy(key, u_tab[forWhom].nickname);
	strcat(key, ".nummsg");
	lcaseit(key);
	key_dat.dptr = key;
	key_dat.dsize = strlen(key);
	result = dbm_fetch(db, key_dat);
	if (result.dptr)
		dbm_delete(db, key_dat);
	for (i = 1; i <= MAX_WRITES; i++) {
		sprintf(key, "%s.header%d", u_tab[forWhom].nickname, i);
		lcaseit(key);
		key_dat.dptr = key;
		key_dat.dsize = strlen(key);
		result = dbm_fetch(db, key_dat);
		if (result.dptr)
			dbm_delete(db, key_dat);
		sprintf(key, "%s.message%d", u_tab[forWhom].nickname, i);
		lcaseit(key);
		key_dat.dptr = key;
		key_dat.dsize = strlen(key);
		result = dbm_fetch(db, key_dat);
		if (result.dptr)
			dbm_delete(db, key_dat);
		sprintf(key, "%s.from%d", u_tab[forWhom].nickname, i);
		lcaseit(key);
		key_dat.dptr = key;
		key_dat.dsize = strlen(key);
		result = dbm_fetch(db, key_dat);
		if (result.dptr)
			dbm_delete(db, key_dat);
		}

	sends_cmdout(forWhom, "Record Deleted");
	dbm_close(db);
}

int
nickwritemsg(forWhom, user, message)
	int		forWhom;
	char		*user;
	char		*message;
{
	DBM            *db;
	char           key[64];
	datum          result, key_dat, request;
	char           line[255], timebuf[255];
	int            count, i;

	if ((strlen(user) <= 0) || (strlen(message) <=0)) {
		sends_cmdout(forWhom, "Usage: write nickname message text");
		return -1;
		}

	if (strlen(u_tab[forWhom].realname) == 0) {
		senderror(forWhom, 
			"You must be registered to write a message.");
		return -1;
		}

	if ((db = dbm_open(USERDB, O_RDWR)) == NULL) {
                sprintf(line, "[ERROR] User Database Open: %s", 
                        sys_errlist[errno]);
                mdb(line);
                sprintf(line, "User Database Open: %s", sys_errlist[errno]);
                senderror(forWhom, line);
		return -1;
		}

	bzero(line, 255);
	strcpy(key, user);
	strcat(key, ".nick");
	lcaseit(key);
	key_dat.dptr = key;
	key_dat.dsize = strlen(key);
	result = dbm_fetch(db, key_dat);
	if (!result.dptr) {
		sprintf(line, "%s is not registered", user);
		senderror(forWhom, line);
		dbm_close(db);
		return -1;
		}

	bzero(line, 255);
	strcpy(key, user);
	strcat(key, ".nummsg");
	lcaseit(key);
	key_dat.dptr = key;
	key_dat.dsize = strlen(key);
	result = dbm_fetch(db, key_dat);
	if (!result.dptr) {
		count = 0;
		i = 1;
		}
	else {
		strncpy(line, result.dptr, result.dsize);
		count = atoi(line);
		i = 0;
		}
	count++;
	if (count > MAX_WRITES) {
		senderror(forWhom, "User mailbox full");
		dbm_close(db);
		return -1;
		}
	gettime();
	strftime(timebuf, 255, "%e-%h-%Y %H:%M %Z", localtime(&curtime));
	sprintf(line, "Message left at %s:", timebuf);
	sprintf(key, "%s.header%d", user, count);
	lcaseit(key);
	key_dat.dptr = key;
	key_dat.dsize = strlen(key);
	request.dptr = line;
	request.dsize = strlen(line);
	dbm_store(db, key_dat, request, DBM_INSERT);
	sprintf(key, "%s.from%d", user, count);
	lcaseit(key);
	key_dat.dptr = key;
	key_dat.dsize = strlen(key);
	request.dptr = u_tab[forWhom].nickname;
	request.dsize = strlen(u_tab[forWhom].nickname);
	dbm_store(db, key_dat, request, DBM_INSERT);
	sprintf(key, "%s.message%d", user, count);
	lcaseit(key);
	key_dat.dptr = key;
	key_dat.dsize = strlen(key);
	filtertext(message);
	request.dptr = message;
	request.dsize = strlen(message);
	dbm_store(db, key_dat, request, DBM_INSERT);
	strcpy(key, user);
	strcat(key, ".nummsg");
	lcaseit(key);
	key_dat.dptr = key;
	key_dat.dsize = strlen(key);
	sprintf(line, "%d", count);
	request.dptr = line;
	request.dsize = strlen(line);
	if (i == 1)
		dbm_store(db, key_dat, request, DBM_INSERT);
	else
		dbm_store(db, key_dat, request, DBM_REPLACE);
	sendstatus(forWhom, "Message", "Text saved to file");
	if ((i = find_user(user)) > 0) {
		sprintf(line, "%s is logged in now.", u_tab[i].nickname);
		sendstatus(forWhom, "Warning", line);
		sprintf(line, "You have %d message", count);
		if (count > 1) strcat(line, "s");
		sendstatus(i, "Message", line);
		}

	dbm_close(db);
}

int
nickckmsg(forWhom)
	int		forWhom;
{
	DBM            *db;
	char           key[64];
	datum          result, key_dat, request;
	char           line[255];
	int            count, retval;

	if (strlen(u_tab[forWhom].realname) == 0) {
		return -1;
		}

	if ((db = dbm_open(USERDB, O_RDWR)) == NULL) {
                sprintf(line, "[ERROR] User Database Open: %s", 
                        sys_errlist[errno]);
                mdb(line);
                sprintf(line, "User Database Open: %s", sys_errlist[errno]);
                senderror(forWhom, line);
		return -1;
		}

	bzero(line, 255);
	strcpy(key, u_tab[forWhom].nickname);
	strcat(key, ".nummsg");
	lcaseit(key);
	key_dat.dptr = key;
	key_dat.dsize = strlen(key);
	result = dbm_fetch(db, key_dat);
	if (!result.dptr) {
		strcpy(line, "0");
		request.dptr = line;
		request.dsize = strlen(line);
		dbm_store(db, key_dat, request, DBM_INSERT);
		retval = 0;
		}
	else {
		strncpy(line, result.dptr, result.dsize);
		retval = atoi(line);
		}

	dbm_close(db);

	return(retval);
}

int
nickreadmsg(forWhom)
	int		forWhom;
{
	DBM            *db;
	char           key[64];
	datum          result, key_dat, request;
	char           line[255], from[MAX_NICKLEN+1];
	int            count, i;

	if (strlen(u_tab[forWhom].realname) == 0) {
		senderror(forWhom, 
			"You must be registered to read any messages.");
		return -1;
		}

	if ((db = dbm_open(USERDB, O_RDWR)) == NULL) {
                sprintf(line, "[ERROR] User Database Open: %s", 
                        sys_errlist[errno]);
                mdb(line);
                sprintf(line, "User Database Open: %s", sys_errlist[errno]);
                senderror(forWhom, line);
		return -1;
		}

	bzero(line, 255);
	strcpy(key, u_tab[forWhom].nickname);
	strcat(key, ".nummsg");
	lcaseit(key);
	key_dat.dptr = key;
	key_dat.dsize = strlen(key);
	result = dbm_fetch(db, key_dat);
	if (!result.dptr) {
		strcpy(line, "0");
		request.dptr = line;
		request.dsize = strlen(line);
		dbm_store(db, key_dat, request, DBM_INSERT);
		senderror(forWhom, "No messages");
		}
	else {
		strncpy(line, result.dptr, result.dsize);
		count = atoi(line);
		strcpy(line, "0");
		request.dptr = line;
		request.dsize = strlen(line);
		dbm_store(db, key_dat, request, DBM_REPLACE);
		if (count == 0)
			senderror(forWhom, "No messages");
		else for (i = 1; i <= count; i++) {
			sprintf(key, "%s.header%d", u_tab[forWhom].nickname, i);
			lcaseit(key);
			key_dat.dptr = key;
			key_dat.dsize = strlen(key);
			result = dbm_fetch(db, key_dat);
			if (result.dptr) {
				bzero(line,255);
				strncpy(line, result.dptr, result.dsize);
				sends_cmdout(forWhom, line);
				}
			dbm_delete(db, key_dat);
			sprintf(key,"%s.from%d", u_tab[forWhom].nickname, i);
			lcaseit(key);
			key_dat.dptr = key;
			key_dat.dsize = strlen(key);
			result = dbm_fetch(db, key_dat);
			bzero(from, MAX_NICKLEN+1);
			if (result.dptr)
				strncpy(from, result.dptr, result.dsize);
			else
				strcpy(from, "Server");
			dbm_delete(db, key_dat);
			sprintf(key,"%s.message%d", u_tab[forWhom].nickname, i);
			lcaseit(key);
			key_dat.dptr = key;
			key_dat.dsize = strlen(key);
			result = dbm_fetch(db, key_dat);
			if (result.dptr) {
				bzero(line,255);
				strncpy(line, result.dptr, result.dsize);
				sprintf(pbuf, "%c%s\001%s", M_PERSONAL, 
				   from, line);
				doSend(-1, forWhom);
				/* sends_cmdout(forWhom, line); */
				}
			dbm_delete(db, key_dat);
			}
		}

	dbm_close(db);
}

int
nickwritetime(forWhom, class)
	int		forWhom;
	int		class;
{
	DBM            *db;
	char           key[64];
	datum          result, key_dat, request;
	char           line[255];
	char           timebuf[255];
	int            retval;
	struct tm      *localtime();

	if (strlen(u_tab[forWhom].realname) == 0) {
		return -1;	/* This shouldn't happen */
		}

	gettime();
	strftime(timebuf, 255, "%e-%h-%Y %H:%M %Z", localtime(&curtime));

	if ((db = dbm_open(USERDB, O_RDWR)) == NULL) {
                sprintf(line, "[ERROR] User Database Open: %s", 
                        sys_errlist[errno]);
                mdb(line);
                sprintf(line, "User Database Open: %s", sys_errlist[errno]);
                senderror(forWhom, line);
		return -1;
		}
	strcpy(key, u_tab[forWhom].nickname);
	strcat(key, ".");
	if (class == 0)
		strcat(key, "signon");
	else
		strcat(key, "signoff");
	lcaseit(key);
	key_dat.dptr = key;
	key_dat.dsize = strlen(key);
	request.dptr = timebuf;
	request.dsize = strlen(timebuf);
	result = dbm_fetch(db, key_dat);
	if (!result.dptr) {		 /* no entry */
		dbm_store(db, key_dat, request, DBM_INSERT);
		}
	else {
		dbm_store(db, key_dat, request, DBM_REPLACE);
		}

	dbm_close(db);
}

int
nickchinfo(forWhom, tag, data, max, message)
	int		forWhom;
	char		*tag;
	char		*data;
	int		max;
	char		*message;
{
	DBM            *db;
	char           key[64];
	datum          result, key_dat, request;
	char           line[255];
	char           newstr[255];
	int            retval;

	if (strlen(u_tab[forWhom].realname) == 0) {
		senderror(forWhom, 
			"Setting your name requites that you be registered.");
		return -1;
		}

	if (strlen(data) > max) {
		bzero(newstr, 255);
		strncpy(newstr, data, max);
		data = newstr;
		sprintf (line, "%s truncated to %d characters", message, max);
		senderror(forWhom, line);
		}

	if ((db = dbm_open(USERDB, O_RDWR)) == NULL) {
                sprintf(line, "[ERROR] User Database Open: %s", 
                        sys_errlist[errno]);
                mdb(line);
                sprintf(line, "User Database Open: %s", sys_errlist[errno]);
                senderror(forWhom, line);
		return -1;
		}
	strcpy(key, u_tab[forWhom].nickname);
	strcat(key, ".");
	strcat(key, tag);
	lcaseit(key);
	key_dat.dptr = key;
	key_dat.dsize = strlen(key);
	request.dptr = data;
	request.dsize = strlen(data);
	result = dbm_fetch(db, key_dat);
	if (!result.dptr) {		 /* no entry */
		dbm_store(db, key_dat, request, DBM_INSERT);
		sprintf (line, "%s set to '%s'", message, data);
		sends_cmdout(forWhom, line);
		}
	else {
		dbm_store(db, key_dat, request, DBM_REPLACE);
		sprintf (line, "%s set to '%s'", message, data);
		sends_cmdout(forWhom, line);
		}

	dbm_close(db);
}

int
nickchpass(forWhom, oldpw, newpw)
	int		forWhom;
	char		*oldpw;
	char		*newpw;
{
	DBM            *db;
	char           key[64];
	datum          result, key_dat, request;
	char           line[255];
	int            retval;

	if ((db = dbm_open(USERDB, O_RDWR)) == NULL) {
                sprintf(line, "[ERROR] User Database Open: %s", 
                        sys_errlist[errno]);
                mdb(line);
                sprintf(line, "User Database Open: %s", sys_errlist[errno]);
                senderror(forWhom, line);
		return -1;
		}

	strcpy(key, u_tab[forWhom].nickname);
	strcat(key, ".password");
	lcaseit(key);
	key_dat.dptr = key;
	key_dat.dsize = strlen(key);
	result = dbm_fetch(db, key_dat);
	if (!result.dptr) {		 /* This nick isn't registered */
		sprintf(line, "Authorization failure");
		senderror(forWhom, line);
		}
	else {
		bzero(line,255);
		strncpy(line, result.dptr, result.dsize);
		if (strcmp(line, oldpw)) {
			sprintf(line, "Authorization failure");
			senderror(forWhom, line);
			}
		else {
			request.dptr = newpw;
			request.dsize = strlen(newpw);
			if (request.dsize <= 0) {
				sprintf(line, "Missing paramater");
				senderror(forWhom,line);
				}
			else {
				dbm_store(db, key_dat, request, DBM_REPLACE);
				sprintf(line, "Password changed");
				sendstatus(forWhom,"Pass",line);
				strcpy(key, u_tab[forWhom].nickname);
				strcat(key, ".home");
				lcaseit(key);
				key_dat.dptr = key;
				key_dat.dsize = strlen(key);
				strcpy(line, u_tab[forWhom].loginid);
				strcat(line, "@");
				strcat(line, u_tab[forWhom].nodeid);
				request.dptr = line;
				request.dsize = strlen(line);
				dbm_store(db, key_dat, request, DBM_REPLACE);
				}
			}
		}

	dbm_close(db);
}

int
nickwrite(forWhom, password)
	int             forWhom;
	char           *password;
{
	DBM            *db;
	char           key[64];
	datum          result, key_dat, request;
	char           line[255];
	int            retval, i, j;

	if (strlen(password) <= 0) {
		senderror (forWhom, "Password cannot be null");
		return -1;
		}

	if ((db = dbm_open(USERDB, O_RDWR)) == NULL) {
                sprintf(line, "[ERROR] User Database Open: %s", 
                        sys_errlist[errno]);
                mdb(line);
                sprintf(line, "User Database Open: %s", sys_errlist[errno]);
                senderror(forWhom, line);
		return -1;
		}

	strcpy(key, u_tab[forWhom].nickname);
	strcat(key, ".password");
	lcaseit(key);
	key_dat.dptr = key;
	key_dat.dsize = strlen(key);
	result = dbm_fetch(db, key_dat);
	if (!result.dptr) {		/* This nick isn't registered */
		strcpy(line, password);
		request.dptr = line;
		request.dsize = strlen(line);
		dbm_store(db, key_dat, request, DBM_INSERT);

		strcpy(key, u_tab[forWhom].nickname);
		strcat(key, ".nick");
		lcaseit(key);
		key_dat.dptr = key;
		key_dat.dsize = strlen(key);
		strcpy(line, u_tab[forWhom].nickname);
		request.dptr = line;
		request.dsize = strlen(line);
		dbm_store(db, key_dat, request, DBM_INSERT);

		strcpy(key, u_tab[forWhom].nickname);
		strcat(key, ".home");
		lcaseit(key);
		key_dat.dptr = key;
		key_dat.dsize = strlen(key);
		strcpy(line, u_tab[forWhom].loginid);
		strcat(line, "@");
		strcat(line, u_tab[forWhom].nodeid);
		request.dptr = line;
		request.dsize = strlen(line);
		dbm_store(db, key_dat, request, DBM_INSERT);
		sprintf(mbuf, "Nick registered");
		sends_cmdout(forWhom, mbuf);
		strcpy(u_tab[forWhom].realname, "registered");
		nickwritetime(forWhom, 0);
		}
	else {
		bzero(line, 255);
		strncpy(line, result.dptr, result.dsize);
		if (strcmp(line, password)) {
			sprintf(mbuf, "Authorization failure");
			senderror(forWhom, mbuf);
			bzero(u_tab[forWhom].realname, MAX_REALLEN + 1);
			}
		else {
			sprintf(mbuf, "Nick registered");
			sends_cmdout(forWhom, mbuf);
			strcpy(u_tab[forWhom].realname, "registered");
			nickwritetime(forWhom, 0);
			for (i = 1; i <= MAX_GROUPS; i++)
			if ((g_tab[i].modtimeout > 0.0) &&
			  (strcmp(g_tab[i].missingmod, 
				u_tab[forWhom].nickname)==0)){
			  g_tab[i].modtimeout = 0;
			  g_tab[i].mod = forWhom;
			  bzero(g_tab[i].missingmod, MAX_NICKLEN);
			  sprintf(mbuf, "%s is the active moderator again.",
				u_tab[forWhom].nickname);
			  for (j = 1; j < MAX_REAL_USERS; j++)
				if ((strcasecmp(u_tab[j].group, g_tab[i].name)
				    == 0) && (j != forWhom))
				    sendstatus(j, "Mod", mbuf);
			  sprintf(mbuf, "You are the moderator of group %s",
				g_tab[i].name);
			  sendstatus(forWhom, "Mod", mbuf);
			}
                	if ((i = nickckmsg(forWhom)) > 0)
                        	if (i == 1)
                                	sendstatus(forWhom, "Message", 
						"You have 1 message");
                        	else {
                                	sprintf(mbuf, "You have %d messages", 
						i);
                                	sendstatus(forWhom, "Message", mbuf);
                                }

			}
		}

	dbm_close(db);
}

int
nicklookup(forWhom, theNick)
	int             forWhom;
	char           *theNick;
{
	DBM            *db;
	char           key[64];
	datum          home, nick, request;
	char           line[255];
	char           temp[255];
	char           nickstr[255];
	int            retval;
	int            count = 0;
	char           *s, *p, *lastw;
	char           tmp1, tmp2;

	if (strlen(theNick) <= 0) {
		if ((forWhom > 0) && (forWhom < MAX_REAL_USERS))
			sends_cmdout(forWhom, "Usage: whois nickname");
		return -1;
		}
	if (strlen(theNick) > MAX_NICKLEN) {
		senderror(forWhom, "nickname too long");
		return -1;
		}

	if ((db = dbm_open(USERDB, O_RDONLY)) == NULL) {
                sprintf(line, "[ERROR] User Database Open: %s", 
                        sys_errlist[errno]);
                mdb(line);
                sprintf(line, "User Database Open: %s", sys_errlist[errno]);
                senderror(forWhom, line);
		return -1;
	}
	/* mdb("UserDB is open"); */

	strcpy (key, theNick);
	strcat (key, ".nick");
	lcaseit(key);
	request.dptr = key;
	request.dsize = strlen(key);
	nick = dbm_fetch(db, request);
	if (nick.dptr) {
		bzero(nickstr, 255);
		strncpy(nickstr, nick.dptr, nick.dsize);
		}

	strcpy (key, theNick);
	strcat (key, ".home");
	lcaseit(key);
	request.dptr = key;
	request.dsize = strlen(key);
	home = dbm_fetch(db, request);
	/* mdb("have looked up name"); */

	if (home.dptr) {
		/* mdb("user's name was found"); */
		retval = 0;
		if (forWhom >= 0) {
			bzero(line, 255);
			bzero(temp, 255);
			strcpy(temp, nickstr);
			sprintf(line, "Nickname:     %s", temp);
			while (strlen(line) < 36)
				strcat(line, " ");
			strcat(line, "Address:   ");
			strncat(line, home.dptr, home.dsize);
			sends_cmdout(forWhom, line);
			strcpy (key, theNick);
			strcat (key, ".phone");
			lcaseit(key);
			request.dptr = key;
			request.dsize = strlen(key);
			nick = dbm_fetch(db, request);
			sprintf(line, "Phone Number: ");
			if (!nick.dptr)
				strcat(line, "(None)");
			else
				strncat(line, nick.dptr, nick.dsize);
			while (strlen(line) < 36)
				strcat(line, " ");
			strcpy (key, theNick);
			strcat (key, ".realname");
			lcaseit(key);
			request.dptr = key;
			request.dsize = strlen(key);
			nick = dbm_fetch(db, request);
			strcat(line, "Real Name: ");
			if (!nick.dptr)
				strcat(line, "(None)");
			else
				strncat(line, nick.dptr, nick.dsize);
			sends_cmdout(forWhom, line);

			bzero(line,255);
			bzero(temp,255);
			strcpy (key, theNick);
			strcat (key, ".signon");
			lcaseit(key);
			request.dptr = key;
			request.dsize = strlen(key);
			nick = dbm_fetch(db, request);
			strcpy(line, "Last signon:  ");
			if (nick.dptr) 
				strncat(line, nick.dptr, nick.dsize);
			else
				strcat(line, "(unknown)");
			while (strlen(line) < 36)
				strcat(line, " ");
			bzero(temp,255);
			strcpy (key, theNick);
			strcat (key, ".signoff");
			lcaseit(key);
			request.dptr = key;
			request.dsize = strlen(key);
			nick = dbm_fetch(db, request);
			strcat(line, "Last signoff:  ");
			if (nick.dptr)
				strncat(line, nick.dptr, nick.dsize);
			else
				strcat(line, "(unknown)");
			sends_cmdout(forWhom, line);

			bzero(line,255);
			bzero(temp,255);
			strcpy (key, theNick);
			strcat (key, ".email");
			lcaseit(key);
			request.dptr = key;
			request.dsize = strlen(key);
			nick = dbm_fetch(db, request);
			if (nick.dptr) {
				strcpy(line, "E-mail addr:  ");
				strncat(line, nick.dptr, nick.dsize);
				sends_cmdout(forWhom, line);
				}

			bzero(line,255);
			bzero(temp,255);
			strcpy (key, theNick);
			strcat (key, ".addr");
			lcaseit(key);
			request.dptr = key;
			request.dsize = strlen(key);
			nick = dbm_fetch(db, request);
			if (nick.dptr) {
				strncpy(line, nick.dptr, nick.dsize);
				sends_cmdout(forWhom, "Street Address:");
				s = line;
				strcpy(temp, "  ");
				while (strlen(s) > 0) {
					if (*s == '|') {
						sends_cmdout(forWhom, temp);
						strcpy(temp, "  ");
						}
					else
						strncat(temp, s, 1);
					s++;
					}
				sends_cmdout(forWhom, temp);
				}

			bzero(line,255);
			bzero(temp,255);
			strcpy (key, theNick);
			strcat (key, ".text");
			lcaseit(key);
			request.dptr = key;
			request.dsize = strlen(key);
			nick = dbm_fetch(db, request);
			if (nick.dptr) {
				strncpy(line, nick.dptr, nick.dsize);
				s = line;
				/* traverse s and try to break on a word */
				p = s;
				lastw = p;
				while (*p != '\0') {
					if (*p == '\n') {
						*p++ = '\0';
						strcpy(temp, "Text: ");
						strcat(temp, s);
						sends_cmdout(forWhom, temp);
						count = 0;
						lastw = p;
						s = p;
						continue;
					}
					if (*p == ' ')
				/* remember location of last word break */
						lastw = p;

					/* break line if we are at max length */
					if (count == (MAX_TEXTLEN - 1)) {
						if ((p - lastw) > 40) {
				/* have to break in the middle of a word */
							tmp1 = *(p - 1);
							tmp2 = *p;
							*(p - 1) = '-';
							*p = '\0';
							strcpy(temp, "Text: ");
							strcat(temp, s);
							sends_cmdout(forWhom, temp);
							*(p - 1) = tmp1;
							*p = tmp2;
							p--;
							s = p;
						} else {
				/* break at last space char */
							tmp1 = *lastw;
							*lastw = '\0';
							strcpy(temp, "Text: ");
							strcat(temp, s);
							sends_cmdout(forWhom, temp);
							*lastw = tmp1;
							p = lastw + 1;
							s = p;
						}
						lastw = p;
						count = 0;
					} else {
						count++;
						p++;
					}
				}
				if (count > 0)
					strcpy(temp, "Text: ");
					strcat(temp, s);
					sends_cmdout(forWhom, temp);
				}
			}
		else {
			bzero(line,255);
			bzero(temp,255);
			sprintf(temp, "%s@%s", u_tab[-forWhom].loginid,
				u_tab[-forWhom].nodeid);
			strncat(line, home.dptr, home.dsize);
			if (strcasecmp(line, temp)) retval = -2;
			else {
				bzero(line,255);
				bzero(temp,255);
				strcpy (key, theNick);
				strcat (key, ".secure");
				lcaseit(key);
				request.dptr = key;
				request.dsize = strlen(key);
				nick = dbm_fetch(db, request);
				if (nick.dptr) retval = -2;
				}
			}
	} else {
		if (forWhom >= 0) {
			sprintf(mbuf, "%s is not in the database.", theNick);
			senderror(forWhom, mbuf);
		}
		retval = -1;
	}

	/* close and return */
	dbm_close(db);
	return retval;
}

/* Put your conditionals here if you don't have bsearch */

#ifdef BSEARCH_NEED

/*
 * Copyright (c) 1990 Regents of the University of California. All rights
 * reserved. 
 *
 * Redistribution and use in source and binary forms are permitted provided
 * that: (1) source distributions retain this entire copyright notice and
 * comment, and (2) distributions including binaries display the following
 * acknowledgement:  ``This product includes software developed by the
 * University of California, Berkeley and its contributors'' in the
 * documentation or other materials provided with the distribution and in all
 * advertising materials mentioning features or use of this software. Neither
 * the name of the University nor the names of its contributors may be used
 * to endorse or promote products derived from this software without specific
 * prior written permission. THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE. 
 */

#if defined(LIBC_SCCS) && !defined(lint)
static char     sccsid[] = "@(#)bsearch.c	5.3 (Berkeley) 5/17/90";
#endif				/* LIBC_SCCS and not lint */

/*
 * Perform a binary search. 
 *
 * The code below is a bit sneaky.  After a comparison fails, we divide the work
 * in half by moving either left or right. If lim is odd, moving left simply
 * involves halving lim: e.g., when lim is 5 we look at item 2, so we change
 * lim to 2 so that we will look at items 0 & 1.  If lim is even, the same
 * applies.  If lim is odd, moving right again involes halving lim, this time
 * moving the base up one item past p: e.g., when lim is 5 we change base to
 * item 3 and make lim 2 so that we will look at items 3 and 4. If lim is
 * even, however, we have to shrink it by one before halving: e.g., when lim
 * is 4, we still looked at item 2, so we have to make lim 3, then halve,
 * obtaining 1, so that we will only look at item 3. 
 */

char           *
bsearch(key, base0, nmemb, size, compar)
	register void  *key;
	void           *base0;
	size_t          nmemb;
	register size_t size;
	register int    (*compar) ();
{
	register char  *base = base0;
	register int    lim, cmp;
	register void  *p;

	for (lim = nmemb; lim != 0; lim >>= 1) {
		p = base + (lim >> 1) * size;
		cmp = (*compar) (key, p);
		if (cmp == 0)
			return (p);
		if (cmp > 0) {	/* key > p: move right */
			base = (char *) p + size;
			lim--;
		}		/* else move left */
	}
	return (NULL);
}

#endif				/* sun || ultrix */
