/* Copyright (c) 1991 by John Atwood deVries II. */
/* For copying and distribution information, see the file COPYING. */

/* "icb" global variables */

#include "server.h"
#include "config.h"
#include "groups.h"
#include "users.h"
#include "../murgil/ipcf.h"

/* the world */
USER_ITEM u_tab[MAX_USERS]; /* that many users possible */
GROUP_ITEM g_tab[MAX_GROUPS]; /* only one group for now */

/* non-global definitions */
char messagebuffer[1024];		/* generic large buffer */
char packetbuffer[USER_BUF_SIZE];		/* packet buffer */

/* global defs */
long TimeToDie = -1.0;
int ShutdownNotify = 0;
int restart = 0;
char *pp = packetbuffer;	/* packet pointer */
char *pbuf = &packetbuffer[1];	/* packet buffer pointer */
char *mbuf = messagebuffer;	/* message buffer */
char thishost[MAXHOSTNAMELEN];	/* our hostname */
time_t curtime;			/* current time */
short int S_kill[MAX_REAL_USERS];

/* lookup tables */

/* commands */
char *command_table[] =
{
	"drop",
	"shutdown",
	"wall",
	"beep",
	"cancel",
	"g",
	"invite",
	"pass",
	"boot",
	"status",
	"topic",
	"motd",
	"m",
	"echoback",
	"name",
	"v",
	"w",
	"whereis",
	"restart",
	"news",
	"hush",
	"shush",
	"s_help",
	"exclude",
	"shuttime",
	"notify",
	(char *) 0
};

char *status_table[] =
{
        "r",	/* restricted */
        "m",	/* moderated */
        "p",	/* public */
        "i",	/* invisible */
        "s",	/* secret */
        "v",	/* visible */
	"q",	/* quiet */
	"n",	/* normal */
	"l",	/* loud */
	"name", /* name of the group */
	"?",	/* list this table */
        (char *) 0
};

char *auto_table[] =
{
        "read",		/* read messages left for you */
        "whois",	/* whois (lookup) */
        "p",		/* register (loginid, nodeid, nickname, password) */
        "rname",	/* set or change real name */
        "write",	/* leave a message for someone */
        "text",		/* text message */
	"addr",		/* snailmail address */
	"phone",	/* phone number */
        "delete",	/* delete some item */
        "info",		/* information on this service */
        "help",		/* help for use of the service */
        "?",		/* list this table */
	"cp",		/* change password */
	"email",	/* e-mail address */
	"secure", 	/* Secure more secure */
	"nosecure", 	/* Secure less secure */
        (char *) 0
};

/* flags set in .icbdrc */
int m_whoheader = 1;	/* who header output */
int m_groupheader = 1;	/* group header output */
int m_nomesg = 0;	/* turn off messages while in icbd */
int m_watchtime = 0;	/* using boring time format */

GLOBS gv = {
	ICBDLOG,	/* logfile */
	"normal",	/* timedisplay */
};
