/* Copyright (c) 1990 by Carrick Sean Casey. */
/* Modifications Copyright (c) 1991 by John Atwood deVries II */
/* For copying and distribution information, see the file COPYING. */

#include "server.h"

/* name list routines */

/* add a name to the list */

nlput(nl, name)
NAMLIST * nl;
char *name;
{
	char *malloc();
	STRLIST *sp;

/* mdb("entered nlput"); */
/* nldump(*nl); */
	/* hunt for user within list */
	for (sp = nl->head; sp; sp = sp->next)
		if (!strcasecmp(name, sp->str)) {
			/* found user -- put at head of list */
			strunlink(sp, &nl->head, &nl->tail);
			strlinkhead(sp, &nl->head, &nl->tail);
/*			sp->val = n; */
			nl->p = nl->head;
			return;
		}

	/* user wasn't found */
/* mdb("user wasn't found"); */
	if (nl->num < nl->max) {
		/* make a new entry for the user */
/* mdb("make a new entry for them"); */
		if ((sp = (STRLIST *) malloc (sizeof(STRLIST) + strlen(name))) == NULL) {
			mdb("[ERROR] nlput out of memory for names");
			return;
		}
/* mdb("copying the name"); */
		strcpy(sp->str, name);
/*		sp->val = n; */
		strlinkhead(sp, &nl->head, &nl->tail);
		nl->num++;
	} else {
		/* name list full, link user to head, remove tail */
/* mdb("name list supposedly full"); */
		sp = nl->tail;
		strunlink(sp, &nl->head, &nl->tail);
		free(sp);
		nl->num--;
		if ((sp = (STRLIST *)
		 malloc (sizeof(STRLIST) + strlen(name))) == NULL) {
			mdb("[ERROR] nlput out of memory for names");
			return;
		}
/* mdb("copying the name"); */
		strcpy(sp->str, name);
/*		sp->val = n; */
		strlinkhead(sp, &nl->head, &nl->tail);
		nl->num++;
	}
/* mdb("setting p to the head of the list"); */
	nl->p = nl->head;
}

/* return a name */
/* repeatedly called, will cycle through entries */

char *
nlget(nl)
NAMLIST * nl;
{
	STRLIST *p = nl->p;

	nl->p = nl->p->next;
	if (nl->p == 0)
		nl->p = nl->head;
/*	*np = p->val; */
	return(p->str);
}
	

/* return number of names in name list */

nlcount(nl)
NAMLIST nl;
{
	return(nl.num);
}

nlclear(nl)
NAMLIST * nl;
{
	STRLIST *tmp, *p;

	if (nl) {
		p = nl->p;
		while (p) {
			tmp = p->next;
			free(p);
			p = tmp;
		}
	}
	nl->num = 0;
	nl->p = nl->head = nl->tail = 0;
}

nlinit(nl, max)
NAMLIST * nl;
int max;
{
        nl->num = 0;
        nl->p = nl->head = nl->tail = 0;
	nl->max = max;
}

int nldelete(nl, name)
NAMLIST  * nl;
char * name;
{
	STRLIST * namep;
	namep = strgetnode(name, nl->head, 1, 0);
	if (namep != NULL) {
		strunlink(namep, &nl->head, &nl->tail);
		nl->p= nl->head;
		if (nl->num > 0) {
			nl->num--;
			if (nl->num == 0)
				nl->p = 0; /* just in case */
		} else {
			mdb("tried to make nl.num negative");
		}
		return 0;
	} else {
		return -1;
	}
}

int nlpresent(name, nl)
char name[];
NAMLIST nl;
{
	if (nl.num > 0) return (strgetnode(name, nl.head, 1, 0) != NULL);
		else	return (NULL != NULL);
}

int nlmatch(name, nl)
char name[];
NAMLIST nl;
{
	if (nl.num > 0) return (strgetnode(name, nl.head, 1, 1) != NULL);
		else	return (NULL != NULL);
}
