/* Copyright (c) 1990 by Carrick Sean Casey. */
/* For copying and distribution information, see the file COPYING. */

/* In the future, this file will include everything a user needs to */
/* know about the client-server protocol */

#include <sys/types.h>

/* macros */

/* this gets used a lot */
#define setlen (*pp = (unsigned char) (strlen(pbuf) + 1))

/* message types */
/* note: changing these necessitates upgrading the protocol number */

#define M_LOGIN		'a'	/* login packet */
#define M_LOGINOK	'a'	/* login packet */
#define M_OPEN		'b'	/* open msg to group */
#define M_PERSONAL	'c'	/* personal msg */
#define M_STATUS	'd'	/* status update message */
#define M_ERROR		'e'	/* error message */
#define M_IMPORTANT	'f'	/* special important announcement */
#define M_EXIT		'g'	/* tell other side to exit */
#define M_COMMAND	'h'	/* send a command from user */
#define M_CMDOUT	'i'	/* output from a command */
#define M_PROTO		'j'	/* protocol version information */
#define M_BEEP		'k'	/* beeps */
#define M_PING		'l'	/* ping packet */
#define M_PONG		'm'	/* return for ping packet */

/* These are new definitions for the protocol */
#define S_PERSONAL	M_PERSONAL
