/* Copyright 1991 by John Atwood deVries II. */
/* For copying and distribution information, see the file COPYING. */

/* primitives to deal with admin commands */

#include "server.h"
#include "externs.h"
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>

s_drop(n, argc)
int n;
int argc;
{
	int TheVictim;

	if (argc == 2) {
		/* fields[1] can be a string, not just a single nick */
		TheVictim = find_user(getword(fields[1]));
		if (TheVictim < 0) {
			senderror(n, "User not found.");
		} else if (check_auth(n))
			disconnectuser(TheVictim);
		else if (valuser(u_tab[TheVictim].nickname,
				getword(get_tail(fields[1]))) == 0) {
				sprintf(mbuf,"You have been disconnected by %s",
					u_tab[n].nickname);
				sendstatus(TheVictim, "Drop", mbuf);
				sprintf (mbuf,"[DROP] %s (%d) dropped %s (%d)", 
					u_tab[n].nickname, n, 
					getword(fields[1]), TheVictim);
				mdb(mbuf);
				S_kill[TheVictim]++;
				}
		else
			senderror(n, "Authentication failure.");
	} else
		mdb("drop: wrong number of parz");
}

s_shutdown(n, argc)
int n;
int argc;
{
	int user;
	char line[255];

	/* before we even look at what they sent us, are the allowed? */
	if (!check_auth(n)) {
		senderror(n,"You are not authorized to do this.");
		return (-1);
	}
	if (argc == 2) {
		/* fields[1] is when and comments, separated by a blank */
/*		mdb(getword(fields[1])); */
/*		mdb(get_tail(fields[1]));  why we are shutting down*/
		/* BUG	we are presuming when is always now.
			...but then, I don't know how to schedule
			anything anyhow.
			we are presuming that no warning is given */
		/* icbexit(); */
		sprintf(line, "Server going down in %ld minute(s)!", 
			atol(fields[1]));
        	for (user=0; user < MAX_REAL_USERS; user++)
			if (u_tab[user].login == 1)
                        	sendimport(user,"Shutdown", line);
		TimeToDie = time(NULL) + 60.0 * atol(fields[1]);
		ShutdownNotify = 0;
		if (atol(fields[1]) < 300)
			ShutdownNotify++;
	} else {
		mdb("shutdown: wrong number of parz");
	}
}

s_restart(n, argc)
int n;
int argc;
{
	int icbdump();
	int user, ret;
	char *args[3];
	char *env[2];
	char tbuf[255];

	/* before we even look at what they sent us, are the allowed? */
	if (!check_auth(n)) {
		senderror(n,"You are not authorized to do this.");
		return (-1);
	}
       	for (user=0; user < MAX_REAL_USERS; user++)
		if (u_tab[user].login == 1)
                       	sendimport(user,"Restart", 
			 "Server restarting...please be patient.");
	mdb("[RESTART] Server restarting");
	icbdump();
	close_logs();
	args[0] = "icbd";
	args[1] = "-R";
	args[2] = NULL;
	env[0] = "RESTART=Y";
	env[1] = NULL;
	ret = fcntl(6, F_GETFD, 0);
	if (fork()) exit(0);
	if (execve("./icbd", args, env) < 0) {
		sprintf(tbuf, "[ERROR] RESTART failed: %s", 
			sys_errlist[errno]);
		mdb(tbuf);
       		for (user=0; user < MAX_REAL_USERS; user++)
			if (u_tab[user].login == 1)
               	        	sendimport(user,"Restart", 
				 "Restart not done.");
		mdb("[RESTART] Restart failed");
		return -1;
		}
}

s_wall(n, argc)
int n;
int argc;
{
	int user;

	/* before we even look at what they sent us, are the allowed? */
	if (!check_auth(n)) {
		senderror(n,"You are not authorized to do this.");
		return (-1);
	}
	if (argc == 2) {
/*		mdb(fields[1]);  text of message */
		/* send it only to the real users */
        	for (user=0; user < MAX_REAL_USERS; user++) {
			if (u_tab[user].login == 1) {
                        	sendimport(user,"WALL", fields[1]);
                	}
        	}
	} else {
		mdb("wall: wrong number of parz");
	}
}

int check_auth(n)
int n;
{
	int auth;

	auth = 0;
	sprintf(mbuf, "[INFO] Checking authoritzation of %s (%s)", u_tab[n].nickname,
		u_tab[n].password);
	mdb(mbuf);
	if (strcasecmp(u_tab[n].nickname, "ADMIN") == 0)
		auth++;
	if (strcasecmp(u_tab[n].password, TheKey) == 0)
		auth++;
	return (auth == 2);
}
